//+------------------------------------------------------------------+
//|                                                  Flat Market.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                        Flat Market Indicator.mq4 |
//|                                 Copyright  2010, wabbit.com.au. |
//|                                        http://www.wabbit.com.au  |
//|                                                                  |
//|                   {FLAT MARKET INDICATOR (FMI) by Piotr Wojdy?o} |
//|                                     {indicator of "flat market"} |
//|       http://trader.online.pl/MSZ/e-w-Flat_Market_Indicator.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, wabbit.com.au"
#property link      "http://www.wabbit.com.au"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_level1 1.05
#property indicator_level2 0
#property indicator_level3 0.2
#property indicator_levelcolor Peru
#property indicator_maximum 1
#property indicator_minimum -0.1


extern int     periods     = 7;
extern int  SMMAperiods = 7;
extern int  HHVperiods  = 7;
extern double  FMILvl      =0.15;

extern bool   ShowArrows       = false;
extern string ArrowsIdentifier = "Flat MKT";
extern color  ArrowUpColor     = Cyan; //Green;
extern color  ArrowDownColor   = Yellow; //Crimson; //Red

double FMI[];
double MMA[];
double SMMA[];
double TDF[];
double trend[];

int init()
{
   IndicatorBuffers(5) ;
   IndicatorDigits(Digits);

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,FMI);
   SetIndexDrawBegin(0, 3*periods);

   SetIndexBuffer(1,MMA);
   SetIndexBuffer(2,SMMA);
   SetIndexBuffer(3,TDF);
   SetIndexBuffer(4,trend);
   
   SetIndexLabel(0,"RK-FMI");
   SetIndexLabel(1,"mma");
   SetIndexLabel(2,"smma");
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,"fmi-trend");
   SetIndexStyle(4,DRAW_NONE);
   
   //My name
   IndicatorShortName("RK-Flat Market-wArrows ("+ periods +","+ SMMAperiods +","+HHVperiods +"  FMIlvl= "+FMILvl+  ")  ");
   //IndicatorShortName("RK-Flat Market-wArrows ("+ periods +","+ SMMAperiods +","+HHVperiods +"  FMIlvl= "+FMILvl+  ")  ");
   //Comment("Copyright  http://www.pointzero-indicator.com");
  
   
   return(0);
}

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
  }   
return(0);
}

int start()
{
   int i;
   double IMPETMMA,IMPETSMMA,DIVMA,AVERIMPET,HHV;
   
   int counted_bars = IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   for(i = limit; i >= 0; i--)
   {
      MMA[i] = iMA(NULL,0,periods,0,MODE_EMA,PRICE_CLOSE,i);
   }
   
   for(i = limit-1; i >= 0; i--)
   {
      SMMA[i] = iMAOnArray(MMA,0,SMMAperiods,0,MODE_EMA,i);

      IMPETMMA = MMA[i] - MMA[i+1];
      IMPETSMMA = SMMA[i] - SMMA[i+1];
      
      DIVMA = MathAbs(MMA[i] - SMMA[i]);
      AVERIMPET= (IMPETMMA + IMPETSMMA)/2.0;
      TDF[i] = MathAbs(DIVMA * MathPow(AVERIMPET,3));
      HHV = TDF[ArrayMaximum(TDF,HHVperiods*3,i)];
      if(HHV!=0.0) FMI[i] = TDF[i]/HHV; else FMI[i] = 0.0;
      trend[i] = trend[i+1];
  
  if (FMI[i] >  FMILvl) trend[i] = 1;
  if (FMI[i] <  FMILvl) trend[i] = -1; 
     
    manageArrow(i);
    }
   
   //manageAlerts();

   return(0);
}

void manageArrow(int x)
{
   if (ShowArrows)
   {
      double dist = iATR(NULL,0,20,x)/1.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      if (trend[x] != trend[x+1])
         {
            string name = ArrowsIdentifier+Time[x];
            if (trend[x] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],Low[x]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,221);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
            }
            else
            if (trend[x] == -1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],High[x]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,222);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
            }
         }
   }
}